failed to set hardware filter to promiscuous mode with Windows 11
The Problem only occurs with LAN adapters.
At virtualbox, WLAN, WWAN promiscuous mode can be enabled at capture start.

USB LAN nor docking is working.
31 is `ERROR_GEN_FAILURE`.  NT status codes that translate to `ERROR_GEN_FAILURE` include a bunch of "somebody wrote to executable memory" codes, `STATUS_WIM_NOT_BOOTABLE`, and `STATUS_UNSUCCESSFUL`, which is, I guess, the NT status equivalent of `ERROR_GEN_FAILURE`, as in "something bad happened but I'm not going to tell you what it was".

There appear to be a lot of places in the driver that return `STATUS_UNSUCCESSFUL`.
Okay Error found:
Installing the Driver for Windows 10 instead of them for Windows 11 and it works again.
I don't know if it's a driver or npcap error.

Drivers are for Realtek USB devices: https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-usb-3-0-software



Can confirm I see the same issue with a Dell WD19DC dock which contains a Realtek RTL8153 USB GbE controller. Was working fine prior to Windows 11 upgrade from Windows 10 21H2. Current driver is `rtu53cx22x64.sys` v1153.8.20.608 (Date: 9/06/2022),

Happy to provide whatever further information would be of assistance but unsure what's most helpful.

EDIT: Using Wireshark v3.6.8 with npcap v1.71.
Just a thought: could it be related to a lack of support for the new [NetAdapterCx](https://learn.microsoft.com/en-us/windows-hardware/drivers/netcx/) driver model?

I have no idea if Npcap is expected to "_Just Work_" with NetAdapterCx drivers or if additional work is required.

The [latest](https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-usb-3-0-software) Windows 11 driver for the RTL8153 has the following details:

- Driver: `rtu53cx22x64.sys`
- Version: 1153.8.20.608
- Date: 9/06/2022
- Type: NetAdapterCx
- NDIS Version: 6.85

The [latest](https://www.realtek.com/en/component/zoo/category/network-interface-controllers-10-100-1000m-gigabit-ethernet-usb-3-0-software) Windows 10 driver for the RTL8153 has the following details:

- Driver: `rtump64x64.sys`
- Version: 10.52.20.608
- Date: 8/06/2022
- Type: NDIS miniport
- NDIS Version: 6.40

The Windows 10 driver works fine with Wireshark while the Windows 11 driver has the described error on starting capture.
Exactly same situation here. Using Intel I225-V wired adapter, Windows 11, and Wireshark 4.0.0. 
Downgrading to `NDIS68` (v1.1.3.28) solves this issue for me. 
On Windows 11, get the same message with Wireshark 4.0.0 and npcap 1.71 (but not with npcap 1.60) on the Ethernet interface (with the Wi-Fi, it was fine).

I reported the issue on Wireshark Q&A : https://ask.wireshark.org/question/29016/cannot-initiate-capture-session-on-a-device-after-having-installed-400/
My workaround after installing Wireshark 4.0.0 was to downgrade npcap to 1.60. This means some regression has been introduced in 1.71.
Device manager shows Realtek PCIe GbE Family controller, date 2021-01-27, version 1.0.0.4.
Same. Error introduced after upgrade to 1.71; resolved by downgrading back to 1.60. Using Killer E3100 2.5 Gbps interface.
I, too, was able to resolve my error (Windows 11 / Wireshark 4.0.1) by downgrading npcap from 1.71 to 1.60. Thanks for the info!
A colleague of mine (who does not have a GitHub account) has a similar issue, however, for him it happens on Windows 10. He is using a "QLogic BCM57810" network card, I don't know what chipset this card contains. Downgrading to npcap 1.60 fixed his issue as well. The driver is quite old as QLogic themselves have been bought up multiple times and their successor companies more less seem to have stopped support.
This happens on Windows 10, Aquantia AQtion AQC107 10Gbit Network Adapter. Downgrade to npcap 1.60 fixed it.
Previously worked on 1.60 but got the same error as yours on 1.71. Realtek Gaming 2.5GbeE Family Controller.
Same here, previously worked on 1.60 but not 1.71, Realtek Gaming GbE Family Controller on laptop and Realtek USB GbE Family Controller on PC. Windows 11 x64 22H2 22621.755


downgrade to 1.6 not always work,still got the problem.
I'm getting the same issue in Xemu (QEMU based Xbox Emulator) with an Intel(R) Ethernet Controller I225-V
Exactly the same problem here with a Tripp-Lite, a TP-Link and a Belkin USB adapter. They identify themselves as:

->TP-LINK Gigabit Ethernet USB Adapter
->Realtek USB GbE Family Controller
->Realtek USB GbE Family Controller

Downgraded to NPACP 1.60 and everything works fine.

Question: Are there any USB Network adapters that works with version 1.71 on Win11 at all?

FWIW Npcap 1.72 did not fix this problem yet (Windows 11 22H2, Wireshark 4.0.2):

![image](https://user-images.githubusercontent.com/25136274/207789818-2d19c8fc-0601-4bfc-b3a4-1ed89d7df9e2.png)

Npcap 1.60 still works.
@markkuleinio I installed Wireshark 4.0.2 a few hours ago and it came with npcap 1.71. Thanks for letting me know I should skip 1.72 as well! Hopefully this gets resolved sooner. Reverting the changes might be a good idea until a solution is found.
If there's an Npcap developer watching this, I'd be quite happy to provide the output from a debug build if one can be provided to help track down the root cause.
I encountered the same issue on Windows 11 22H2, 22621.963.

The network adapter is identified as `Lenovo USB Ethernet`, `VID_17EF&PID_720C`.

Downgrading to 1.60 indeed works.
The same issue
Same here... After installing 1.60 it works...
@jtippet Somebody asks, in [this comment](https://github.com/nmap/npcap/issues/628#issuecomment-1279899071), "could it be related to a lack of support for the new [NetAdapterCx](https://learn.microsoft.com/en-us/windows-hardware/drivers/netcx/) driver model?"

I haven't found anything at learn.microsoft.com that looks like reference documentation for NetAdapterCx - some tutorial information, but nothing giving raw API details, siuch as, for example,  how a NetAdapterCx driver is notified that an OID get or set operation is performed.  What happens if you do an OID_GEN_CURRENT_PACKET_FILTER set operation?  Is a NetAdapterCx driver told that the filter has changed, and what the new filter is?
So, based on the GUID in the bug text and the error dialog, and the DiagReport, from the original bug report, the two adapter with the problem is "Lenovo USB Ethernet", with a manufacturer of Realtek and a service name of rtu53cx22x64, on Windows 11.

Other adapters reported are:

- Realtek RTL8153 USB GbE controller, with the same driver, rtu53cx22x64.sys, Windows 11.
- Intel I225-V, Windows 11.
- Realtek PCIe GbE Family controller, unknown Windows version.
- Intel Killer E3100, Windows 11.
- Aquantia (Marvell?) AQtion AQC107 10Gbit Network Adapter, Windows 10.
- Realtek Gaming 2.5GbeE Family Controller, unknown Windows version.
- Realtek Gaming GbE Family Controller and Realtek USB GbE Family Controller, Windows 11.
- Xemu (QEMU based Xbox Emulator) with an Intel(R) Ethernet Controller I225-V, unknown Windows version.
- TP-LINK Gigabit Ethernet USB Adapter, unknown chipset, unknown Windows version.
- Lenovo USB Ethernet, VID_17EF&PID_720C, Windows 11.
- Intel Killer E3100, e3k25cx21x64 driver, Windows 11.

So this is not a problem only with USB adapters, given that there's at least one report with a PCIe controller.

And this is not a problem only with Windows 11, given that there are some reports on Windows 10.

It *might* be a NetAdapterCx problem, *if* the driver for the adapter is, in all cases, a NetAdapterCx driver rathr than an NDIS driver.
Thanks for all of the reports!  This data really helps and we'll be discussing the issue in tomorrow's engineering meeting.  We've also added it to the list of issues we're planning to fix for the upcoming 1.73 release.
> Is a NetAdapterCx driver told that the filter has changed, and what the new filter is?

Yes. A NetAdapterCx-based driver would advertise its supported flags by calling NetAdapterSetReceiveFilterCapabilities. When p-mode is enabled, the adapter receives an `EVT_NET_ADAPTER_SET_RECEIVE_FILTER` callback.

[The actual netadaptercx code that handles this](https://github.com/microsoft/Network-Adapter-Class-Extension/blob/ca1e33c85a0270077a9d527f745897be3e5f6443/netcx/adapter/nxadapter.cpp#L1791) is available on github; you can see that it does a few checks to make sure the requested flags are supported by the driver, a bit of synchronization with other state-changing events, then sends the flags down. I'm not seeing a lot of opportunities for bugs to lurk in here, but maybe I'm overlooking something; there are a lot of customer reports, so _something's_ clearly broken.
Seeing the same issue so here is a further data point:

Asus ROG STRIX Z690-A Gaming WiFi D4 motherboard
Windows 11 with latest updates
Intel wired ethernet controller I225-V 
Driver version 2.1.2.3 (21/09/22)

Thanks for looking into this.
Hi @Peter-Simpson , @rpersak, and @MaksymSofer, @davidebeatrici, @httpstorm, @ralish and anyone else experiencing this issue.  Thanks for the reports, and can you please confirm using the Wireshark Help -> About dialogue that you are using Npcap Version 1.72?  It was released on December 14 with a fix that we thought might resolve this.  But if you're getting Npcap through Wireshark rather than from https://npcap.com, you might be using an older Npcap still. We'd like to hear from more people using 1.72.  Thanks!
Confirmed (Npcap 1.72):

> Version 4.0.2 (v4.0.2-0-g415456d13370). ... Running on 64-bit Windows (22H2), build 22621, with 12th Gen Intel(R) Core(TM) i7-1270P (with SSE4.2), with 32435 MB of physical memory, with GLib 2.72.3, with PCRE2 10.40 2022-04-14, with Qt 5.15.2, with Npcap version 1.72, based on libpcap version 1.10.2-PRE-GIT, with c-ares 1.18.1, with GnuTLS 3.6.3, with Gcrypt 1.10.1, with nghttp2 1.46.0, with brotli 1.0.9, with LZ4 1.9.3, with Zstandard 1.5.2, without AirPcap, with light display mode, without HiDPI, with LC_TYPE=Finnish_Finland.utf8, binary plugins supported. 

> The capture session could not be initiated on capture device "\Device\NPF_{A586373D-21B0-41D4-995B-3617E49AEBCE}" (failed to set hardware filter to promiscuous mode: A device attached to the system is not functioning.  (31)).
> Please turn off promiscuous mode for this device

The same error also with Wireshark 4.0.3 if that matters:

> Version 4.0.3 (v4.0.3-0-gc552f74cdc23). ... Running on 64-bit Windows (22H2), build 22621, with 12th Gen Intel(R) Core(TM) i7-1270P (with SSE4.2), with 32435 MB of physical memory, with GLib 2.72.3, with PCRE2 10.40 2022-04-14, with Qt 5.15.2, with Npcap version 1.72, based on libpcap version 1.10.2-PRE-GIT, with c-ares 1.18.1, with GnuTLS 3.6.3, with Gcrypt 1.10.1, with nghttp2 1.46.0, with brotli 1.0.9, with LZ4 1.9.3, with Zstandard 1.5.2, without AirPcap, with light display mode, without HiDPI, with LC_TYPE=Finnish_Finland.utf8, binary plugins supported. 
> It was released on December 14 with a fix that we thought might resolve this. 

It might resolve some cases, but if the driver, for whatever reason, rejects attempts to set the receive filter, and either 1) it returns `STATUS_UNSUCCESSFUL` or 2) it returns `STATUS_NOT_SUPPORTED`, *as would make sense in this case*, but something in the subsequent code path turns it into `STATUS_UNSUCCESSFUL`, that would cause this problem, even with the current Npcap code.  Pull request #656 restores a workaround for that problem, by setting the `C` bit in the status (see my huge comment added by that commit).
@guyharris Thanks! Checking it out now.
I have a TP-Link adapter showing the problem I would be pleased to you. Just let me know where you want it sent.
No npcap 1.72 has the same problem at my pc
![image](https://user-images.githubusercontent.com/5597327/215049473-71cc98c8-a7ec-4a6f-bfb9-ae61d052d464.png)

Windows 11 Version 22H2 (22621.1105)
Lenovo Ethernet: USB\VID_17EF&PID_A387&REV_3103

Hi, 

I recently had a similar issue and found that I had to uninstall NCAP 1.7 and then to install v1. 60. Wireshark then worked ok in promiscuous mode. 

Best wishes Peter 

⁣Get BlueMail for Android ​

On 27 Jan 2023, 09:12, at 09:12, Felix ***@***.***> wrote:
>No npcap 1.72 has the same problem at my pc
>![image](https://user-images.githubusercontent.com/5597327/215049473-71cc98c8-a7ec-4a6f-bfb9-ae61d052d464.png)
>
>Windows 11 Version 22H2 (22621.1105)
>Lenovo Ethernet: USB\VID_17EF&PID_A387&REV_3103
>
>
>-- 
>Reply to this email directly or view it on GitHub:
>https://github.com/nmap/npcap/issues/628#issuecomment-1406214945
>You are receiving this because you were mentioned.
>
>Message ID: ***@***.***>

@fyodor Can confirm I'm running Npcap v1.72. Let me know if I can offer any further data.
xemu

![Screenshot 2023-01-29 012200](https://user-images.githubusercontent.com/1505374/215311501-9a10d1c3-726b-401f-b985-4de6cfdf4445.png)

Thanks for the info, this fixed my problem.  I was seeing "the capture session could not be initiated on capture device failed to set hardware filter to promiscuous mode"  .  I tried downgrading from wireshark 4.0.3 to 3.6.11 but that did not fix it.  However, downgrading the npcap version did fix it.  I had Npcap 1.71, downgrading to 1.60 fixed it.  I can now run wireshark on my ethernet interface again.  I use a Laptop Dell Precision 5400, which is usb-c thunderbolt connected to my dell docking station WD19TB.  

This is how i could see my npcap version.... 

before...
C:\Program Files\Npcap>NPFInstall.exe
NPFInstall for Npcap 1.71 ( https://npcap.com )

after...
C:\Program Files\Npcap>NPFInstall.exe
NPFInstall for Npcap 1.60 ( http://npcap.org )

i didn't reboot, it just worked after getting npcap 1.60 from here....
https://npcap.com/dist/
So can we say this problem could be resolved in next version?
I have the same problem. Use npcap v1.60 can fix it.
windows: win11 22H2 (22621.1105)
wireshark v4.03
npcap: v1.71/v1.72
Any news on this issue? 

Wireshark just rolled out an update again, and if you don't pay attention, it by default "upgrades" Npcap to version 1.71, and you are out.


Thanks everyone.  We're hoping PR #656 by @guyharris will resolve this.  It has been merged and we're hoping to release Npcap 1.73 in the coming weeks with this and other improvements.  
Note that "resolve" means "cause the failure to set the filter to promiscuous mode to be reported to the libpcap component of Npcap in such a fashion that it can recognize that particular failure and ignore it, allowing capture to proceed", not "prevent the failure from occurring".  The failure might be a problem with the Ethernet adapter driver or some part of NDIS, which may mean that there's nothing Npcap can do to fix it, because it's a problem with software not provided by the Npcap or libpcap developers.

My pull request merely causes the Npcap driver to report that error to userland the way earlier versions of that driver did.

I don't know whether this failure is real, in that the capture isn't done as a promiscuous-mode capture, or bogus, in that the adapter is in promiscuous mode.  If you're only trying to capture packets to or from the machine running the program, it doesn't matter whether it's done in promiscuous mode or not.  If you're trying to capture other machines' traffic from a non-switched Ethernet or from a "mirror port" (or whatever your switch vendor calls it), it *does* matter.

Libpcap should probably be changed to report that failure as a warning, so that programs that recognize the warning can report it before continuing to capture.  I think Wireshark may report warnings in this case.
@guyharris I think you're a bit too humble :D Thanks 💯 times for the "fix"!
Unfortunately update 1.73 didn't help with this issue. Just installed 1.73 and when using with wireshark I am still getting 
![image](https://user-images.githubusercontent.com/22233613/229144051-222a52b4-e923-4c58-b364-755805be15f3.png)
with Intel(R) Ethernet Controller I225-V on windows 11.
Confirmed:

> The capture session could not be initiated on capture device "\Device\NPF_{A586373D-21B0-41D4-995B-3617E49AEBCE}" (failed to set hardware filter to promiscuous mode: Couldn't get error message for error (3758096385)).
> Please turn off promiscuous mode for this device

Wireshark on Windows 11, with a Realtek-based USB-C NIC.

Version 4.0.4 (v4.0.4-0-gea14d468d9ca).
...
Running on 64-bit Windows (22H2), build 22621, with 12th Gen Intel(R) Core(TM)
i7-1270P (with SSE4.2), with 32435 MB of physical memory, with GLib 2.72.3, with
PCRE2 10.40 2022-04-14, with Qt 5.15.2, **with Npcap version 1.73, based on
libpcap version 1.10.3**, with c-ares 1.18.1, with GnuTLS 3.6.3, with Gcrypt
1.10.1, with nghttp2 1.46.0, with brotli 1.0.9, with LZ4 1.9.3, with Zstandard
1.5.2, without AirPcap, with light display mode, without HiDPI, with
LC_TYPE=Finnish_Finland.utf8, binary plugins supported.

3758096385 is 0xE0000001.

The bits in the upper nibble of that are 1110, so, as per [the format of an NTSTATUS value](https://learn.microsoft.com/en-us/openspecs/windows_protocols/ms-erref/87fba13e-bf06-450e-83b1-9241dc81e781), that has:

- a 2-bit Sev field, containing the severity, with the value 0b11 = 0x3, for `STATUS_SEVERITY_ERROR`;
- a 1-bit C field, which is 1 for customer-defined values, and the value is 1;
- a 1-bit N field, which is reserved and must be zero, and *is* zero.

The Facility field is 0 and the Code field is 1.

The C bit is set in the driver in order to try to prevent some currently-unknown code from "helpfully" mapping `STATUS_NOT_SUPPORTED` to `STATUS_UNSUCCESSFUL`.  `STATUS_UNSUCCESSFUL` is 0xC0000001, so this appears to be a case where either 1) `STATUS_NOT_SUPPORTED` was mapped to `STATUS_UNSUCCESSFUL` *before* we set the C bit or 2) something is failing and returning `STATUS_UNSUCCESSFUL`.

`STATUS_UNSUCCESSFUL` gets mapped to the Windows error code `ERROR_GEN_FAILURE`.  Neither are very useful return code values, and should only be returned if *no other status value* is available, because all they tell the caller, the developer, and the user is "I couldn't do that for some unspecified reason", which is rather difficult to translate into a *specific cause* to fix.
The places *inside the NPF driver* where `STATUS_UNSUCCESSFUL` is returned - as opposed to returning a status from other NT kernel-mode code, with *that* code returning `STATUS_UNSUCCESSFUL` - are:

- any place that calls `NPF_Deny()`:
   - if Npcap is compiled with `NPCAP_READ_ONLY`, write calls call it;
- in `funcBIOC_OID()`, in the `if (pOpen->pFiltMod->Dot11 && (OidData->Oid == OID_GEN_MEDIA_IN_USE || OidData->Oid == OID_GEN_MEDIA_SUPPORTED))` case, if it's a "set" operation;
- in `NPF_GetCurrentOperationMode()`, if the number of bytes processed, as returned by `NPF_DoInternalRequest()`, isn't equal to `sizeof(CurrentOperationMode)`;
- in `NPF_Read()`, if `Open->Size` is 0;
- any place that calls `EXIT_FAILURE()` - but no places do, so `EXIT_FAILURE()` should perhaps be removed;
- in `NPF_Write()`, if:
   - `Open->pFiltMod->MaxFrameSize` is 0;
   - `buflen` is greater than `Open->pFiltMod->MaxFrameSize`;
- in `NPF_BufferedWrite(), if `Open->pFiltMod->MaxFrameSize` is 0.

None of those look as if they should cause `STATUS_UNSUCCESSFUL` to be returned in this case.
> @guyharris I think you're a bit too humble :D Thanks 💯 times for the "fix"!

No, I'm not too humble - this *didn't* fix the problem (so putting "fix" in quotes was appropriate).

However, it did help *narrow down the cause of the problem*, as the reported errors indicate that `STATUS_UNSUCCESSFUL` is probably being returned from the attempt to set the filter.  It's probably the result of a change between 1.60 and 1.7x where, somehow, the setting of the filter changed in a way that causes drivers to report `STATUS_UNSUCCESSFUL` for an attempt to set the filter.
Another report that 1.73 didn't fix the problem was provided by @youngbeggar in #665 . (Closed as duplicate of this one)
Oh, and `NDIS_STATUS_FAILURE` is defined as...

...`((NDIS_STATUS)STATUS_UNSUCCESSFUL)`

so anything in Npcap that returns `NDIS_STATUS_FAILURE` is returning `STATUS_UNSUCCESSFUL`.  That means some additional places where `STATUS_UNSUCCESSFUL` is returned are:

- `NPF_OidGetUlongNonpagedPtr()`, if the number of bytes processed, as returned by `NPF_DoInternalRequest()`, isn't equal to `sizeof(ULONG)`;
- `NPF_GetDataRateMappingTable()`, if the number of bytes processed, as returned by `NPF_DoInternalRequest()`, isn't equal to `sizeof(DOT11_DATA_RATE_MAPPING_TABLE)`, or if the type, revision, or size of the data rate mapping table aren't what's expected;
- `NPF_SetPacketFilter()`, if the number of bytes processed, as returned by `NPF_DoInternalRequest()`, isn't equal to `sizeof(PacketFilter)`;
- `NPF_SetLookaheadSize()`, if the number of bytes processed, as returned by `NPF_DoInternalRequest()`, isn't equal to `sizeof(ULONG)`;
- `NPF_DoInternalRequest()`, if `NdisFOidRequest()` returns `NDIS_STATUS_SUCCESS` but the `RequestType` argument is neither `NdisRequestSetInformation`, `NdisRequestQueryInformation`, nor `NdisRequestMethod`.

`NPF_DoInternalRequest()` has code that, if `NdisFOidRequest()` returns `NDIS_STATUS_SUCCESS` and the `RequestType` argument is one of the values listed, truncates the number of bytes processed value to a value no larger than the `InformationBufferLength` argument for `NdisRequestSetInformation`, and`NdisRequestQueryInformation` and no larger than the `OutputBufferLength` argument for `NdisRequestMethod`.  The comment before that code says:

> The driver below should set the correct value to BytesWritten or BytesRead.  But now, we just truncate the value to InformationBufferLength due to bug in Nortel driver ipsecw2k.sys v.  4.10.0.0 that doesn't set the BytesWritten correctly
>  The driver is the one shipped with Nortel client Contivity VPN Client V04_65.18, and the MD5 for the buggy (unsigned) driver is 3c2ff8886976214959db7d7ffaefe724 *ipsecw2k.sys (there are multiple copies of this binary with the same exact version info!)
> The (certified) driver shipped with Nortel client Contivity VPN Client V04_65.320 doesn't seem affected by the bug. 


Looking at changes between 1.60 and 1.70 - this bug first started showing up in 1.70, I think - one change, 600b264ef749ef013674469e0f1e4574a0812430, adds code to `NPF_Restart()` so that, if it's supplied with `OID_GEN_MINIPORT_RESTART_ATTRIBUTES` in the restart parameters, saves the `SupportedPacketFilters` value and uses that to mask out all unsupported filter flags before handing it to the driver.

`NPF_CreateFilterModule()` initializes the `NPCAP_FILTER_MODULE` structure to 0, and then sets individual members, so the `SupportedPacketFilters` value starts out as 0, and will not be set until the filter driver's [FILTER_RESTART callback function](https://learn.microsoft.com/en-us/windows-hardware/drivers/ddi/ndis/nc-ndis-filter_restart), `NPF_Restart()`, is called.

Is there any guarantee that this will be called before the first attempt at opening an NPF device and setting its filter is made?  If not, that attempt could be made with a `SupportedPacketFilters` value of 0, meaning that the packet filter value will be 0.  The [OID_GEN_CURRENT_PACKET_FILTER documentation](https://learn.microsoft.com/en-us/windows-hardware/drivers/network/oid-gen-current-packet-filter) seems to indicate that the filter starts out as 0:

> For miniport adapters whose media type is **NdisMedium802_3** or **NdisMedium802_5**, if the miniport driver does not set a bit for a particular packet type in response to this query, the protocol driver will not receive packets of that type. Consequently, a protocol driver can disable packet reception by calling the [**NdisOidRequest**](https://learn.microsoft.com/en-us/windows-hardware/drivers/ddi/ndis/nf-ndis-ndisoidrequest) or [**NdisCoOidRequest**](https://learn.microsoft.com/en-us/windows-hardware/drivers/ddi/ndis/nf-ndis-ndiscooidrequest) function using a filter of zero.

so Ethernet and Token Ring drivers *shouldn't* report an error if the filter is set to 0, but I don't assume driver writers Read The Fine Manual or, if they do, Pay Full Attention To The Fine Manual, so it *could* be that a driver is getting a request to set the filter to 0, either because the restart callback hasn't been called yet or the driver is supplying 0 as a `SupportedPacketFilters` value of 0, and rejecting that filter with `NDIS_STATUS_FAILURE`.
The number-of-bytes-processed tests mentioned in [this earlier comment](https://github.com/nmap/npcap/issues/628#issuecomment-1493120792) are there in 1.60, so that's *probably* not the problem.
Just another datapoint that v1.73 has the same issue for me as well.

To assist with when the issue started (at least in my configuration) I retested all the Npcap releases from v1.60:

- 1.60: Works
- 1.70: Doesn't work -> no adapters listed in Wireshark
- 1.71: Doesn't work -> unable to set promiscuous mode
- 1.72: Doesn't work -> unable to set promiscuous mode
- 1.73: Doesn't work -> unable to set promiscuous mode

I had this issue suddenly show up on Friday afternoon (Melbourne Australia time). I had been using Wireshark 4.0.3 (with npcap 1.71) successfully prior to then, including earlier that day. I didn't change anything to make it suddenly stop working. So it was weird that the issue suddenly started happening in the afternoon. I am just wondering if it's possible that Windows 11 did a network driver automatic update.

* Windows 11
* Dell laptop XPS 15 9520 with a Dell dock.
* Realtek USB GbE Family Controller
    * USB 0bda:8153
    * rtu53cx22x64
    * Driver `C:\WINDOWS\SYSTEM32\DRIVERSTORE\FILEREPOSITORY\RTU53CX22X64.INF_AMD64_23312DEE5C4E1993\RTU53CX22X64.SYS` (1153.9.823.2022, 985.23 KB (1,008,872 bytes), 27/10/2022 12:16 AM)

For me, npcap 1.73 didn't work; npcap 1.60 works.
Thanks everyone who has reported this issue. For those of you with Npcap 1.73, please provide this additional info:

1. Windows version and architecture (i.e. Windows 11 x86_64 or Windows 10 ARM64)
2. Did you install Npcap with the "raw wifi" option? If you are unsure, run this Powershell command: `Get-NetAdapterBinding -ComponentID INSECURE_NPCAP_WIFI`
3. What type of interface is giving the error? e.g. wired Ethernet, WiFi, mobile/WWAN, VPN, etc.
4. Do any interfaces *not* give the error?
5. Does the error go away if you uncheck the promiscuous mode checkbox?
1. Windows 11 22H2, build 22621, x86_64
2. No raw wifi option (or any other checkbox) was selected during Npcap install (the PS command you suggested gives this error: "Get-NetAdapterBinding : No MSFT_NetAdapterBindingSettingData objects found with property 'ComponentID' equal to 'INSECURE_NPCAP_WIFI'.  Verify the value of the property and retry.")
3. Wired ethernet: Realtek-based USB-C adapter
4. No errors reported when capturing with other interfaces: Intel AX211 WiFi, Fibocom LTE adapter, VMware virtual adapters
5. Yes, error goes away if promiscuous mode is unchecked (but not all traffic will be captured, naturally)

1. Windows 11 22H2 x86_64
2. Yes. The provided PowerShell command returns one result for the "WiFi" interface.
3. Ethernet, though as part of a dock connected over USB. The dock is a Dell TB18DC while the chipset is a Realtek  RTL8153.
4. Yes, both the built-in Ethernet and Wi-Fi cards capture fine. The Ethernet is a "Intel Ethernet Connection (11) I219-LM" and the Wi-Fi is a "Intel Wi-Fi 6 AX201".
5. Yes
Great, this seems like it's related to the Realtek or other USB ethernet devices. I have one here I will test with later today. Most likely this is due to a miniport driver behavior that is either incorrect or just an edge case we have not completely accounted for.
Hello. No it is not, as I mentioned https://github.com/nmap/npcap/issues/628#issuecomment-1491986957

1. Windows 11 22H2 x86_64
2.  Npcap Packet Driver (NPCAP) (Wi-Fi)                INSECURE_NPCAP_WIFI  True
3. onboard ethernet, Intel(R) Ethernet Controller I225-V (I am not using wifi adapter to capture)
4. only gives error when I check promiscuous mode, otherwise works fine

Update 1:

ASUS [distributes drivers](https://rog.asus.com/motherboards/rog-strix/rog-strix-x670e-f-gaming-wifi-model/helpdesk_download/) for this intel controller. 
Description of the package says:
Intel I225 / I226 LAN Driver V1.1.4.38 For Windows 10 64-bit.
Intel I225 / I226 LAN Driver V2.1.3.3 For Windows 11 64-bit.

I tried to install Win10 driver on windows 11 and it works. Also promiscuous mode works as it suppose to.
Once I reinstalled drivers with Win11 version, error with setting promiscuous mode arises.

Not sure what is the difference between V1.1.4.38 and V2.1.3.3 driver. But pcap acts differently on each of them.
More info: I do not have a Realtek adapter here; the adapter I have does not have the issue. However, when looking at the driver downloads for Realtek chipsets, it appears that for Windows 11 they switched to a NetAdapterCx driver, which is a framework for building NIC drivers on WDF, using netadaptercx.sys to handle the NDIS interoperations. As such, it's unlikely that this is the result of another driver misbehaving, but more likely something we need to adapt to.

If anyone wants to help further diagnose, you can run the Windows built-in tool Driver Verifier to see if it can identify any issues and force a bugcheck (BSoD). Here are the steps:

1. Install Npcap 1.73 (I will post a debug build later that is preferable, but the standard version is fine, too).
2. Run the following command as Administrator: `verifier.exe /bootmode oneboot /driver npcap.sys /flags 0x2209BB`
3. Reboot.
4. Use Wireshark as usual. Attempt to capture packets on the Realtek adapter.
5. If there is a crash (BSoD), send `C:\Windows\MEMORY.dmp` or the latest minidump from `C:\Windows\Minidump\` to me at dmiller@nmap.com
6. If no crash, reboot to clear verifier settings.


@mirozitnansky Thanks for the additional info! I downloaded that driver and it is also a NetAdapterCx driver, so that confirms the common feature of all these systems. I will be looking for any adapters I have on hand that have NetAdapterCx-based drivers available to see if I can reproduce.
> More info: I do not have a Realtek adapter here; the adapter I have does not have the issue. However, when looking at the driver downloads for Realtek chipsets, it appears that for Windows 11 they switched to a NetAdapterCx driver, which is a framework for building NIC drivers on WDF, using netadaptercx.sys to handle the NDIS interoperations. As such, it's unlikely that this is the result of another driver misbehaving, but more likely something we need to adapt to.

[A comment from 2022](https://github.com/nmap/npcap/issues/628#issuecomment-1279899071) also suggested that this might be an issue with NetAdapterCx drivers.

I filed MicrosoftDocs/windows-driver-docs#3456 against the Microsoft documentation; the documentation on porting miniport drivers to NetAdapterCx might not be making it clear enough that the ported driver should call `NetAdapterSetReceiveFilterCapabilities()` to set the bitset of supported packet filter capabilities.  If that's not being done by a NetAdapterCx driver, that might cause the Npcap driver to send a packet filter with some bits that need to be set not being set and, if either the NetAdapterCx code or the miniport driver responds to that with an error that maps to `NDIS_STATUS_FAILURE`/`STATUS_UNSUCCESSFUL`, that could produce these symptoms.
Oh, look, the NetAdapterCx code is [open source](https://github.com/microsoft/Network-Adapter-Class-Extension)!

[`NetAdapterSetReceiveFilterCapabilities()`](https://github.com/microsoft/Network-Adapter-Class-Extension/blob/release_21H2/netcx/adapter/nxadapterapi.cpp#L606) just passes the `NET_ADAPTER_RECEIVE_FILTER_CAPABILITIES *` on to `nxAdapter->SetReceiveFilterCapabilities(*ReceiveFilter);`.

[The `SetReceiveFilterCapabilities` method](https://github.com/microsoft/Network-Adapter-Class-Extension/blob/release_21H2/netcx/adapter/nxadapter.cpp#L3898) of [an `NxAdapter` instance](https://github.com/microsoft/Network-Adapter-Class-Extension/blob/release_21H2/netcx/adapter/nxadapter.hpp) just copies the structure to the `m_receiveFilterCapabilities` element of the instance.

[The `SetReceiveFilter` method](https://github.com/microsoft/Network-Adapter-Class-Extension/blob/release_21H2/netcx/adapter/nxadapter.cpp#L1790) of an `NxAdapter` instance will...

...return `STATUS_NOT_SUPPORTED` if the `m_receiveFilterCapabilities` element of the instance is 0.

I'm not seeing any obvious way where `NDIS_STATUS_FAILURE`/`STATUS_UNSUCCESSFUL` would be returned by the NetAdapterCx code for an attempt to set the packet filter; furthermore, the driver routine that's called by the `SetReceiveFilter` method has no return value (`void`), so it can't report a failure.

So either something in NDIS is returning `NDIS_STATUS_FAILURE`/`STATUS_UNSUCCESSFUL` or the failure is happening in some other code path.
I can run some debug build with both driver types, I you'd like to trace something.
> So either something in NDIS is returning NDIS_STATUS_FAILURE/STATUS_UNSUCCESSFUL or the failure is happening in 
> some other code path.

If someone had just tried to compile using `gcc -Wall` and/or `clang-cl -Wall`, he'd notice there are many warnings like
`warning: variable 'plen' may be uninitialized when used here`. 

I cooked up this GNU [makefile](https://gist.github.com/gvanem/d63ab3ad81883c9c5f757bb7e62a0606) to try to use clang-cl to build `NPF.sys`. It worked, but I've not tried to use it for real.
Be warned, using `clang-cl -Wall` with the Windows-DDK is a very noisy experience. 
BTW. the code doesn't even compile without these:
 * `-DHAVE_DOT11_SUPPORT`
 *  `-DHAVE_WFP_LOOPBACK_SUPPORT`
 *  `-DHAVE_RX_SUPPORT`. 
 
So what's the purpose of these?


> > So either something in NDIS is returning NDIS_STATUS_FAILURE/STATUS_UNSUCCESSFUL or the failure is happening in
> > some other code path.
> 
> If someone had just tried to compile using `gcc -Wall` and/or `clang-cl -Wall`, he'd notice there are many warnings like `warning: variable 'plen' may be uninitialized when used here`.

There's no variable named `plan` in either Openclos.c or Packet.c, which is where this *particular* code path exists.  However, either or both of those files may produce warnings when compile with gcc/clang and `-Wall`; it might be worth looking into whether the MSVC warning level could be cranked up here as well.
> There's no variable named plan

`plen`.
> > There's no variable named plan
> 
> `plen`.

Damn you, autocorrect.  What I checked for in the Npcap source was `plen`, not `plan`.
Same Problem with npcap 1.73.
I ordered a USB Ethernet adapter that uses the Realtek drivers, and after updating the driver from the Realtek website, I was able to reproduce the issue. I used the debug build of the Npcap driver and the DebugView application from MS Sysinternals to get a log of what is happening. Here is the relevant section:
```
NPF_IoControl: ENTER
NPF_IoControl: Function code is 0021a820 Input size=0000000f Output size 0000000ffuncBIOC_OID: BIOCSETOID Request: Oid=0001010e, Length=00000004
NPF_StartUsingOpenInstance: OpenStatus = 2; MaxState = 2
NPF_SetPacketFilter: pFiltMod=FFFFC00B179CF5D0, PacketFilter=0x20
NPF_SetPacketFilter: New packet filter: 0x2b
NPF_DoInternalRequest: ENTER
NPF_Status: status 40010024
NPF_OidRequestComplete: ENTER
NPF_OidRequestComplete: pFiltMod(FFFFC00B179CF5D0) INTERNAL_REQUEST Oid 0x1010e, Status 0
NPF_OidRequestComplete: EXIT
NPF_DoInternalRequest: pFiltMod(FFFFC00B179CF5D0) OID SET 0x1010e: Status = 0
NPF_DoInternalRequest: EXIT
NPF_SetPacketFilter: BytesProcessed != sizeof(PacketFilter), BytesProcessed = 0, sizeof(PacketFilter) = 0x4
NPF_SetPacketFilter: EXIT
funcBIOC_OID: Original NdisFOidRequest() Status = 0xc0000001
funcBIOC_OID: Custom NdisFOidRequest() Status = 0xe0000001
NPF_IoControl: Status = 0xe0000001
NPF_IoControl: EXIT
```

The same `BytesProcessed != sizeof(PacketFilter)` issue happens when setting any packet filter, regardless of promiscuous mode or not. Since this *is* a violation of the NDIS specification (a driver must set the `NDIS_OID_REQUEST.DATA.SET_INFORMATION.BytesRead` to the number of bytes read for a set operation), this can be viewed as a bug in the Realtek driver. However, Npcap should probably not be so picky when it comes to requiring this, especially since  so many people are being prevented from using it because of this. So I will change `NPF_SetPacketFilter()` and several other similar functions to not require this in the case of `NDIS_STATUS_SUCCESS`.
Awesome work, @dmiller-nmap!
> this can be viewed as a bug in the Realtek driver

Or, if that driver is a NetAdapterCx driver, possibly in the NetAdapterCx code.  (I may take a deep dive later, but it's a bit of a case of a twisty little maze of code paths.)

But, in either case, it's in code we're forced to deal with, so, yes, we need to stop caring whether the code does the right thing or not.
@guyharris I think you're right. It doesn't seem like a NetAdapterCx client driver knows anything about NDIS_OID_REQUEST structures, so it should be a change to MS's code that is needed.
My initial comment is that **Npcap 1.74** works with Wireshark 4.0.5 on Windows 11.

Thanks!

https://npcap.com/#download
Yes I can also confirm, with 1.74 it's working again.

Thanks!
Working on Intel I225 / I226 LAN Driver V2.1.3.3  NetAdapterCx  driver.
Thank for your effort and great job!
Yep, also working on Realtek "RTL8111/8168 PCI Express Gigabit Ethernet controller" driver v1.0.0.14.
Many thanks!
Installing last version of Npcap resolved problem.
Confirm work with my "Realtek PCIe 2.5GbE Family Controller" (Default Microsoft driver 1.0.0.14 at 01.02.2021)
Many thanks 
1. Microsoft Windows [Version 10.0.22621.1778]
2.  Name                           DisplayName                                        ComponentID          Enabled
----                           -----------                                        -----------          -------
Realtek                        Npcap Packet Driver (NPCAP) (Wi-Fi)                INSECURE_NPCAP_WIFI  True
TPLink                         Npcap Packet Driver (NPCAP) (Wi-Fi)                INSECURE_NPCAP_WIFI  True
3.  Problem was only with Realtek Ethernet adapter, WiFi works fine. 
Driver is (from DUMo)
Realtek PCIe GbE Family Controller	Realtek	1168.12.320.2023	Update available (1168.13.424.2023)

npcap was 1.71

Upgrade npcap to 1.75 resolves problem. Thanks all.

I have the same issue and actually i don't know how to solve it...I need wireshark for a debug at work... without it i don't know how to do that, ok little edit, i solved it giving wireshark admin's powers

It’s all fixed. Just install the latest NPcap:

https://npcap.com/dist/npcap-1.76.exe

The WireShark installer is installing an older version of Npcap, that does have the problem.

From: Quadrani ***@***.***>
Sent: Friday, September 22, 2023 11:16 AM
To: nmap/npcap ***@***.***>
Cc: Jens Munk ***@***.***>; Manual ***@***.***>
Subject: Re: [nmap/npcap] failed to set hardware filter to promiscuous mode with Windows 11 (Issue #628)

CAUTION: This email originated from outside of the organization. Do not click links or open attachments unless you recognize the sender and know the content is safe.


I have the same issue and actually i don't know how to solve it...I need wireshark for a debug at work... without it i don't know how to do that

—
Reply to this email directly, view it on GitHub<https://github.com/nmap/npcap/issues/628#issuecomment-1731089137>, or unsubscribe<https://github.com/notifications/unsubscribe-auth/ABNGFSABXX6R36VFP45AUC3X3VJL3ANCNFSM6AAAAAAQHUHNJQ>.
You are receiving this because you are subscribed to this thread.Message ID: ***@***.******@***.***>>

> I encountered the same issue on Windows 11 22H2, 22621.963.
> 
> The network adapter is identified as `Lenovo USB Ethernet`, `VID_17EF&PID_720C`.
> 
> Downgrading to 1.60 indeed works.

Oh man thanks a lot, the problem was fixed!!!! It's time to filter my network traffic!!!!!! A big hug from Spain, bro
> It's time to filter my network traffic!!!!!!

[The filter referred to here](https://learn.microsoft.com/en-us/windows-hardware/drivers/network/oid-gen-current-packet-filter) is not the same as the "capture filter", to use the Wireshark term; it doesn't do fine-grained filtering such as "tcp end not host random.machine.example.com", it just specifies what broad categories of link-layer packets are received.  It's mainly used to turn promiscuous mode on or off.

The "capture filter" filtering mechanism works with or without this bug fix (assuming this bug doesn't prevent you from capturing at all).
> > I encountered the same issue on Windows 11 22H2, 22621.963.
> > The network adapter is identified as `Lenovo USB Ethernet`, `VID_17EF&PID_720C`.
> > Downgrading to 1.60 indeed works.
> 
> Oh man thanks a lot, the problem was fixed!!!! It's time to filter my network traffic!!!!!! A big hug from Spain, bro

the issue is fixed already, no need to downgrade, you just have to upgrade to the latest version because it's not included in the Wireshark installer yet